/*
  @(#)icmp.h	1.2	06/10/00	gholland@cs.tamu.edu
*/

#ifndef ns_icmp_h
#define ns_icmp_h


//#define ICMP_VERSION

// ICMP "Destination Unreachable" Packet -- as implemented for ELFN
/*
  0                   1                   2                   3
  0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ - Header -
 |     Type      |     Code      |          Checksum             |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ 
 |                             unused                            |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ -- Data --
 |                       Source Address                          |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ IP
 |                    Destination Address                        |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ --
 |          Source Port          |       Destination Port        |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ TCP
 |                        Sequence Number                        |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ ----------
*/

#define ICMP_HDR_LEN 		8 
#define ICMP_DU_DATA_LEN	16
#define ICMP_DU_PKT_LEN 	(ICMP_HDR_LEN + ICMP_DU_DATA_LEN) 

enum ICMP_MESSAGE_TYPES {
	ICMP_TYPE_ECHO_REPLY = 0,
	ICMP_TYPE_DST_UNREACHABLE = 3,
	ICMP_TYPE_SOURCE_QUENCH = 4
/*
    5  Redirect
    8  Echo
   11  Time Exceeded
   12  Parameter Problem
   13  Timestamp
   14  Timestamp Reply
   15  Information Request
   16  Information Reply
*/
};

enum ICMP_DST_UNREACHABLE_CODES {
	ICMP_CODE_NET_UNREACHABLE = 0,
	ICMP_CODE_HOST_UNREACHABLE = 1,
/*
      2 = protocol unreachable;
      3 = port unreachable;
      4 = fragmentation needed and DF set;
*/
	ICMP_CODE_SR_FAILED = 5,
	ICMP_CODE_SR_QUEUED = 6,
	ICMP_CODE_SR_SENT = 7,
	ICMP_CODE_SR_DROPPED = 8
};

struct hdr_icmp {
	int	type_;
	int	code_;
        inline int& type() { return (type_); }
        inline int& code() { return (code_); }

	static int offset_;           /* offset for this header */
	inline int& offset() { return offset_; }
};

#endif
